local Flies_List = {}
function Agrunt_Hornet()
	for k, v in pairs(Flies_List) do
		-- Calculate Information
		local Ang = math.rad(v.rot)
		local rot = v.rot
		x = v.x + math.sin(Ang) * 16
		y = v.y - math.cos(Ang) * 16

		-- Check if the fly can pass it
		if tile(math.floor(x/32),math.floor(y/32),"wall") then
			rot = -rot
			if tile(math.floor(v.x/32),math.floor(y/32),"wall") then
				rot = rot + 180
			end
			Sound3("starkkz/weapons/hornet/ag_buzz"..math.random(1,3)..".wav",v.x,v.y,180)
		end
		x = v.x + math.sin(math.rad(rot)) * 8
		y = v.y - math.cos(math.rad(rot)) * 8

		-- Update fly information
		v.x = x
		v.y = y
		v.rot = rot
		v.destroy = v.destroy - 1
		imagepos(v.img,x,y,rot)
		if v.destroy <= 0 then
			freeimage(v.img)
			Flies_List[k] = nil
		end

		if Flies_List[k] then
			for n, i in pairs(NPC_Tab) do
				if Flies_List[k] and DistBetween(i:x(), i:y(), v.x, v.y) < 20 then
					freeimage(v.img)
					Flies_List[k] = nil
					i:onHit(k, "Agrunt Hornet", 8 + math.random(-2,2), true)
					break
				end
			end

			for _, id in pairs(player(0,"table")) do
				if Flies_List[k] and DistBetween(player(id,"x"), player(id,"y"), v.x, v.y) < 20 then
					freeimage(v.img)
					Flies_List[k] = nil
					local h, a = CalcDamage(player(id,"health"), player(id,"armor"), 8 + math.random(-2,2))
					if h > 0 then
						parse("sethealth "..id.." "..h)
						parse("setarmor "..id.." "..a)
					else
						parse('customkill 0 "Alien Grunt Hornet" '..id)
					end
					break
				end
			end
		end
	end
end
timer(20, "Agrunt_Hornet", "",0)

local npc_agrunt = npc_class:new()
RegisterNPC("Agrunt", npc_agrunt)

npc_agrunt.health = 200
npc_agrunt.team = 0
npc_agrunt.attackdist = 300
npc_agrunt.movementdelay = 40
npc_agrunt.movementspeed = 8
npc_agrunt.movementmax = 16
npc_agrunt.sprite = "gfx/HL2D/agrunt.bmp"
npc_agrunt.spritescalex = 1.2
npc_agrunt.spritescaley = 1.2
npc_agrunt.viewdist = 380
npc_agrunt.width = 16
npc_agrunt.height = 16

function npc_agrunt:init()
	self.var = {}
	self.timer = {}

	self.SoundTimer = 0
end

function npc_agrunt:spawnHornetFly(x,y,rot)
	local T = {
		x = x,
		y = y,
		rot = rot,
		destroy = 50,
		img = image("gfx/starkkz/HB.bmp",0,1,3)
	}
	imagepos(T.img, x, y, rot)
	table.insert(Flies_List, T)
end

function npc_agrunt:onDie()
	Sound3("starkkz/npc/agrunt/ag_die"..math.random(1,3)..".wav", self:x(), self:y(),320)
	self:freeslot()
end

function npc_agrunt:onHit(attacker,wpn,dmg,isNPC)
	self.health = self.health - dmg
	if self.health <= 0 then
		return self:onDie()
	end

	if Millisecs() - self.SoundTimer >= 0 then
		self.SoundTimer = Millisecs() + 1000
		Sound3("starkkz/npc/agrunt/ag_pain"..math.random(1,5)..".wav", self:x(), self:y(), 300)
	end
end

function npc_agrunt:onAttack(id,isNPC)
	if self.targetAttackable then
		self.attackdelay = 250 + math.random(-50, 50)
		Sound3("starkkz/npc/agrunt/ag_fire"..math.random(1,3)..".wav", self:x(), self:y(), 300)

		local x = self:x() + math.sin(math.rad(self:rot() + 52)) * 18
		local y = self:y() - math.cos(math.rad(self:rot() + 52)) * 18
		self:spawnHornetFly(x, y, self:rot())
	end
end

function npc_agrunt:onSeeEnemy(id,isNPC)
	if self.lastTarget == 0 then
		Sound3("starkkz/npc/agrunt/ag_attack"..math.random(1,3)..".wav", self:x(), self:y(), 320)
	end
end
