local npc_headcrab = npc_class:new()
RegisterNPC("Headcrab", npc_headcrab)

npc_headcrab.jumpLength = 8
npc_headcrab.damage = 5
npc_headcrab.health = 10

npc_headcrab.team = -1
npc_headcrab.attackdelay = 1500
npc_headcrab.movementspeed = 9.6
npc_headcrab.movementmax = 16
npc_headcrab.movementdelay = 200
npc_headcrab.sprite = "gfx/npc/headcrab.bmp<m>"
npc_headcrab.hitzonemode = 3
npc_headcrab.width = 8
npc_headcrab.height = 8
npc_headcrab.viewdist = 300
npc_headcrab.attackdist = npc_headcrab.jumpLength * 32

function npc_headcrab:init()
	self.var = {}
	self.timer = {}
end

function npc_headcrab:onDie()
	Sound3("headcrab/hc_die"..math.random(1,2)..".wav", self:x(), self:y(), 380)

	self:freeslot()
end

function npc_headcrab:onHit(id, wpn, Damage, isNPC)
	self.health = self.health - Damage
	if self.health <= 0 then
		return self:onDie()
	end
	Sound3("headcrab/hc_pain"..math.random(1,3)..".wav", self:x(), self:y(), 380)
end

function npc_headcrab:Always()
	if self.Attacking then
		local Angle = self:angle(self.throwX, self.throwY)
		local Dist = self:dist(self.throwX, self.throwY)
		local x = self:x() + math.sin(Angle) * 10.24
		local y = self:y() - math.cos(Angle) * 10.24

		--tween_move(self.id, 20, x, y, math.deg(Angle))
		imagepos(self.id, x, y, math.deg(Angle))

		local targets = self:ClosestTargets(16)
		for _, target in pairs(targets) do
			local id = target[1]
			local isNPC = target[2]
			if self:attackable(object_x(id, isNPC), object_y(id, isNPC)) then
				if isNPC then
					NPC_Tab[id]:onHit(self.id, "Headcrab", self.damage, true)
				else
					local h, a = CalcDamage(player(id,"health"), player(id,"armor"), self.damage)
					if h > 0 then
						parse("sethealth "..id.." "..h)
						parse("setarmor "..id.." "..a)
					else
						parse('customkill 0 "Headcrab" '..id)
					end
				end
				self.Attacking = nil
				self:findTargetPath(id, isNPC)
				Sound3("headcrab/hc_headbite.wav", self:x(), self:y(), 380)
				return
			end
		end

		if Dist <= 10.24 then
			self.Attacking = nil
			self:findTargetPath(self.lastTarget)
		end
	end
end

function npc_headcrab:onAttack(id,isNPC)
	if self.targetAttackable and not self.Attacking then
		local Angle = self:angle(self.targetx, self.targety)
		local Dist = self:dist(self.targetx, self.targety)
		if Dist > 256 then
			Dist = 256
		end

		self.throwX = self:x() + math.sin(Angle) * Dist
		self.throwY = self:y() - math.cos(Angle) * Dist
		self.throwAngle = Angle
		self.Attacking = true
		Sound3("headcrab/hc_attack"..math.random(1, 3)..".wav", self:x(), self:y(), 380)
	end
end

function npc_headcrab:onMove(x,y,r)
	if self.Attacking then
		return 1
	end
end

function npc_headcrab:onSeeEnemy(id,isNPC)
	if self.lastTarget == 0 then
		Sound3("headcrab/hc_alert1.wav", self:x(), self:y(), 380)
	end
end
