-- NPC Mod By Starkkz

npc_class = {}

npc_class.team = 0
npc_class.health = 0
npc_class.attackdist = 0
npc_class.attackdelay = 0
npc_class.movementdelay = 0
npc_class.movementspeed = 0
npc_class.sprite = ""
npc_class.hitzonemode = 3
npc_class.spritescalex = 1
npc_class.spritescaley = 1
npc_class.movementsleep = 0

npc_class.last_attack = 0
npc_class.last_move = 0

function npc_class:init()
end

function npc_class:exists()
	if self.id then
		return object(self.id, "exists")
	end
end

function npc_class:Always()
end

function npc_class:UpdateSprite()
end

function npc_class:tweenUpdateSprite(t,x,y,r)
end

function npc_class:onDie()
	self:freeslot()
end

function npc_class:resetTarget()
	self.lastTarget = 0
	self.lastVisual = false
	self.targetNPC = false
end

function npc_class:targetAlive()
	if self.lastTarget == 0 then
		return false
	end
	if self.targetNPC then
		local Table = NPC_Tab[self.lastTarget]
		if Table then
			return Table.health > 0
		end
	else
		return player(self.lastTarget, "health") > 0
	end
end

function npc_class:targetInRange()
	if self.lastTarget == 0 then
		return 0
	end
	return self:distObject(self.lastTarget, self.targetNPC) < self.viewdist
end

function npc_class:onHit(attacker,wpn,dmg,isNPC)
end

function npc_class:onAttack(id,isNPC)
end

function npc_class:onUseEvent(id,range)
end

function npc_class:onMove()
end

function npc_class:walkable(x,y)
	return tile(x, y, "walkable")
end

function npc_class:fixpixels(x,y)
	local modx = x % 32
	local mody = y % 32
	local nx, ny
	if modx <= 8 and not self:walkable(math.floor(x/32)-1, math.floor(y/32)) then
		nx = x + 2
	elseif modx >= 24 and not self:walkable(math.floor(x/32)+1, math.floor(y/32)) then
		nx = x - 2
	else
		nx = x
	end
	if mody <= 8 and not self:walkable(math.floor(x/32), math.floor(y/32)-1) then
		ny = y + 2
	elseif mody >= 24 and not self:walkable(math.floor(x/32), math.floor(y/32)+1) then
		ny = y - 2
	else
		ny = y
	end
	return nx, ny
end

function npc_class:onMoveEvent()
	if self.var.path and self.var.path[self.var.pathpos] then
		local pos = self.var.pathpos
		local tarx
		local tary
		local node = self.var.path[pos]

		if node.pixel then
			tarx = node.x
			tary = node.y
		elseif node.x and node.y then
			tarx = node.x*32 + 16
			tary = node.y*32 + 16
		else
			return nil
		end

		if self:dist(tarx, tary) <= self.movementmax then
			if node.pixel then
				self.var.path = nil
				self.var.pathpos = nil
			else
				self.var.pathpos = pos - 1
			end
		else
			if node.dist and node.dist > 1.42 and not MapTeleporter(node.x, node.y) then
				self.var.path = nil
				self.var.pathpos = nil
			else
				local a = AngleBetween(self:x(), self:y(), tarx, tary)
				local x = self:x() + math.sin(a) * self.movementspeed
				local y = self:y() - math.cos(a) * self.movementspeed
				x, y = self:fixpixels(x, y)

				local allowed, rot = self:onMove(x, y, math.deg(a))
				if not allowed then allowed = 0 end
				if not rot then rot = math.deg(a) end

				if allowed == 0 then
					self:move(x, y, rot)
					return true
				end
			end
		end
	end
end

function npc_class:FindPath(x,y)
	return FindPath(self:tilex(), self:tiley(), x, y)
end

function npc_class:findTargetPath(id,isNPC)
	local target_x = object_x(id, isNPC)
	local target_y = object_y(id, isNPC)

	local target_tx = math.floor(target_x/32)
	local target_ty = math.floor(target_y/32)

	if not self:walkable(target_tx, target_ty) then
		return nil
	end

	if self:freeline(target_x, target_y) then
		self.var.path = {{x = target_x,y = target_y,pixel = true}}
		self.var.pathpos = 1
	else
		if self.var.path and self.var.path[self.var.pathpos] then
			return nil
		else
			self.var.path = self:FindPath(target_tx, target_ty)
			if not self.var.path then
				self.var.pathpos = 0
				self:resetTarget()
			else
				self.var.pathpos = #self.var.path
			end
		end
	end
end

function npc_class:onSeeEnemy(id,isNPC)
end

function npc_class:lostVisual(id,isNPC)
end

function npc_class:find_target_player()
	local closest
	for _, id in pairs(player(0,"tableliving")) do
		local dist = self:dist(player(id,"x"), player(id,"y"))
		if not closest or dist < closest[2] then
			if self.team ~= player(id,"team") then
				if self:attackable(player(id,"x"), player(id,"y")) then
					closest = {id, dist}
				end
			end
		end
	end
	if closest then
		return closest[1], closest[2]
	end
end

function npc_class:find_target_npc()
	local closest
	for id, t in pairs(NPC_Tab) do
		if id ~= self.id and t ~= self and t.health > 0 then
			local dist = self:dist(t:x(), t:y())
			if not closest or dist < closest[2] then
				if self.team ~= t.team then
					if self:attackable(t:x(), t:y()) then
						closest = {id, dist}
					end
				end
			end
		end
	end
	if closest then
		return closest[1], closest[2]
	end
end

function npc_class:find_target()
	if self:targetAlive() and self:targetInRange() then
		return self.lastTarget, self.targetNPC
	end

	local target_player, player_dist = self:find_target_player()
	local target_npc, npc_dist = self:find_target_npc()

	if target_player and not target_npc then
		return target_player, false
	elseif target_npc and not target_player then
		return target_npc, true
	elseif not target_player and not target_npc then
		return nil
	end

	if player_dist <= npc_dist then
		return target_player, false
	end
	return target_npc, true
end

function npc_class:checkVisual(x,y)
	return self:dist(x, y) < self.viewdist
end

function npc_class:freeslot()
	if self:exists() then
		NPC_Tab[self.id] = nil
		if object(self.id, "exists") then
			freeimage(self.id)
		end
	end
end

function npc_class:move(x,y,rot,speed)
	if self:exists() then
		local comp_x = x or self:x()
		local comp_y = y or self:y()
		local comp_rot = rot or self:rot()
		local spd = speed or self.movementdelay

		if comp_x ~= self:x() or comp_y ~= self:y() or comp_rot ~= self:rot() then
			if spd == 0 then
				imagepos(self.id, comp_x, comp_y, comp_rot)
				self:UpdateSprite()
			else
				tween_move(self.id, spd, comp_x, comp_y, comp_rot)
				self:tweenUpdateSprite(spd,comp_x,comp_y,comp_rot)
			end
		end
	end
end

function npc_class:setpos(x,y,rot)
	if self:exists() then
		local comp_x = x or self:x()
		local comp_y = y or self:y()
		local comp_rot = rot or self:rot()

		if comp_x ~= self:x() or comp_y ~= self:y() or comp_rot ~= self:rot() then
			imagepos(self.id, comp_x, comp_y, comp_rot)
			self:UpdateSprite()
		end
	end
end

function npc_class:moveAvail()
	return Millisecs() - self.last_move >= self.movementdelay and Millisecs() - self.last_move >= self.movementsleep
end

function ClosestTargets(id, dist, areNPCs)
	local targets = {}
	if areNPCs then
		local t = NPC_Tab[id]
		for _, p in pairs(player(0,"tableliving")) do
			if t:dist(player(p,"x"), player(p,"y")) < dist then
				table.insert(targets, {p, false})
			end
		end

		for n, tb in pairs(NPC_Tab) do
			if n ~= t.id and n ~= id and t:dist(tb:x(), tb:y()) < dist then
				table.insert(targets, {n, true})
			end
		end
	else
		for _, p in pairs(player(0,"tableliving")) do
			if p ~= id and DistBetween(player(id,"x"), player(id,"y"), player(p,"x"), player(p,"y")) < dist then
				table.insert(targets, {p, false})
			end
		end

		for n, t in pairs(NPC_Tab) do
			if t:dist(player(id,"x"), player(id,"y")) < dist then
				table.insert(targets, {n, false})
			end
		end
	end
	return targets
end

function npc_class:ClosestTargets(dist)
	return ClosestTargets(self.id, dist, true)
end

function npc_class:AddTimer(delay,func,...)
	table.insert(self.timer, {Millisecs() + delay,func,{...}})
end

function npc_class:dist(x,y)
	if x and y then
		return DistBetween(self:x(), self:y(), x, y)
	end
end

function npc_class:distObject(id, isNPC)
	local x, y
	if isNPC then
		x, y = object(id, "x"), object(id, "y")
	else
		x, y = player(id, "x"), player(id, "y")
	end
	if x and y then
		return DistBetween(self:x(), self:y(), x, y)
	end
	return 0
end

function npc_class:angle(x,y)
	return AngleBetween(self:x(), self:y(), x, y)
end

function npc_class:aim(x,y)
	imagepos(self.id, self:x(), self:y(), math.deg(self:angle(x, y)))
end

function npc_class:x()
	if self:exists() then return object(self.id, "x") end
end

function npc_class:y()
	if self:exists() then return object(self.id, "y") end
end

function npc_class:tilex()
	return math.floor(self:x()/32)
end

function npc_class:tiley()
	return math.floor(self:y()/32)
end

function npc_class:rot()
	if self:exists() then return object(self.id, "rot") end
end

function npc_class:sound3(f,radius)
	Sound3(f, self:x(), self:y(), radius)
end

function npc_class:attackable(x,y)
	return attackable(self:x(), self:y(), x, y)
end

function npc_class:freeline(...)
	if #arg < 2 then return nil end
	local sx, sy = self:x(), self:y()
	local Dist = DistBetween(self:x(), self:y(), arg[1], arg[2])
	local Angle = AngleBetween(self:x(), self:y(), arg[1], arg[2])
	for i = 1, Dist, 4 do
		sx = sx + math.sin(Angle) * 4
		sy = sy - math.cos(Angle) * 4
		if not self:walkable(math.floor(sx/32), math.floor(sy/32)) then
			return false
		end
	end
	return true
end

function npc_class:new()
	local t = {}
	setmetatable(t, {__index = self})
	return t
end

function Millisecs()
	return os.clock() * 1000
end

function table.find(tab,var)
	for k, v in pairs(tab) do
		if v == var then return k end
	end
	return false
end

function Sound3(file, x, y, radius)
	for _, id in pairs(player(0,"table")) do
		if DistBetween(x, y, player(id,"x"), player(id,"y")) < radius then
			parse("sv_sound2 "..id.." "..file)
		end
	end
end

function CalcDamage(h,a,d)
	if not h or not a or not d then return nil end

	local d = math.floor(d * game("mp_damagefactor"))
	if a >= 0 and a <= 200 then
		local _a = a - d
		local _h = h - d*(1-game("mp_kevlar"))
		if _a < 0 then
			_h = _h + _a
			_a = 0
		end
		return math.floor(_h), math.floor(_a)
	elseif a == 201 then
		local _h = h - d*0.75
		return math.floor(_h), a
	elseif a == 202 or a == 204 then
		local _h = h - d*0.5
		return math.floor(_h), a
	elseif a == 203 then
		local _h = h - d*0.25
		return math.floor(_h), a
	elseif a == 205 then
		local _h = h - d*0.05
		return math.floor(_h), a
	elseif a == 206 then
		local _h = h - d
		return math.floor(_h), a
	end
end

NPC_Tab = {}
NPC_Info = {}

function RegisterNPC(name,info)
	NPC_Info[name] = info
end

function NewNPC(name)
	local t = NPC_Info[name]
	if t then
		while type(t) == "string" do
			t = _G[t]
		end
		if type(t) == "table" then
			return t:new()
		end
	end
end

function SpawnNPC(name,x,y,rot)
	if NPC_Info[name] then
		local npc = NewNPC(name)

		npc.id = image(npc.sprite, 0, 1, npc.spritemode or 1)
		npc:setpos(x, y, rot)
		npc.lastVisual = false
		npc.lastTarget = 0
		npc.targetNPC = false
		npc.width = npc.width or 32
		npc.height = npc.height or 32
		npc.var = {}

		if npc.id then
			imagescale(npc.id, npc.spritescalex, npc.spritescaley)
			imagehitzone(npc.id, npc.hitzonemode or 3, -npc.width/2, -npc.height/2, npc.width, npc.height)
			npc:init()

			NPC_Tab[npc.id] = npc
			return npc
		end
		return false, "Failed to create NPC, no image id"
	end
	return false, "NPC Class does not exist"
end

function attackable(...)
	if #arg < 4 then return nil end
	local x, y = arg[1], arg[2]
	local Dist = DistBetween(arg[1], arg[2], arg[3], arg[4])
	local Angle = AngleBetween(arg[1], arg[2], arg[3], arg[4])
	for i = 1, Dist, 4 do
		x = x + math.sin(Angle) * 4
		y = y - math.cos(Angle) * 4
		if tile(math.floor(x/32),math.floor(y/32),"wall") then
			return false
		end
	end
	return true
end

function PathMap(x,y)
	if tile(x,y,"walkable") then
		return 0
	end
	return 1
end

function MapTeleporter(x,y)
	if entity(x, y, "exists") and entity(x, y, "typename") == "Func_Teleport" then
		if entity(x, y, "state") then
			return entity(x, y, "int0"), entity(x, y, "int1")
		end
	end
end

function FindPath(fx,fy,tx,ty,Map)
	if Map == nil then Map = PathMap end

	if Map(fx,fy) == 1 or Map(tx,ty) == 1 then
		return nil, "The start or the goal is not walkable"
	end

	local Node = {}
	local curbase = {x = fx,y = fy}
	local openlist = {{x = fx,y = fy}}

	local function Euclidean(fx,fy,tx,ty)
		return math.sqrt((fx-tx)^2 + (fy-ty)^2)
	end

	function CreateNodeConfig(x,y,open)
		if not Node[x] then Node[x] = {} end
		if not Node[x][y] then
			if open == nil then open = false end
			local n = {
				Open = open,
				Closed = false,
				parent = {}
			}
			n.G = 0
			n.H = Euclidean(x,y,tx,ty)
			n.F = n.H
			Node[x][y] = n
		end
	end

	CreateNodeConfig(fx,fy,1)

	local function FixedPath()
		local i = {x = tx,y = ty}
		local path = {}
		while Node[i.x][i.y].parent.x and Node[i.x][i.y].parent.y do
			local parent = Node[i.x][i.y].parent
			local Details = {
				x = i.x,
				y = i.y,
				dist = math.sqrt((i.x - parent.x)^2 + (i.y - parent.y)^2)
			}
			table.insert(path, Details)
			i = parent
		end
		return path, #path, -1
	end

	local function CheckNode(l,x,y,p)
		CreateNodeConfig(x,y)
		if not Node[x][y].Closed and Map(x,y) == 0 then
			local t = {x = x,y = y}
			if p then t.parent = p end
			table.insert(l, t)

			local nx, ny = MapTeleporter(x, y)
			if nx and ny then
				CheckNode(l, nx, ny, t)
			end
		end
	end

	local function AddNode(v,p)
		local score = Node[p.x][p.y].G + math.sqrt((v.x-p.x)^2 + (v.y-p.y)^2)*32
		if not Node[v.x][v.y].Open then
			local pos = #openlist+1
			openlist[pos] = {x = v.x,y = v.y}
			Node[v.x][v.y].Open = pos
			Node[v.x][v.y].parent = p
			Node[v.x][v.y].G = score
			Node[v.x][v.y].F = score + Node[v.x][v.y].H
		elseif score <= Node[v.x][v.y].G then
			Node[v.x][v.y].parent = p
			Node[v.x][v.y].G = score
			Node[v.x][v.y].F = Node[v.x][v.y].G + Node[v.x][v.y].H
		end
	end

	local function LowestNode()
		local lVal, lID
		for k, v in pairs(openlist) do
			if not lVal or Node[v.x][v.y].F < Node[lVal.x][lVal.y].F then
				lVal = v
				lID = k
			end
		end
		return lVal, lID
	end

	local function OpenListEmpty()
		for k, v in pairs(openlist) do
			return false
		end
		return true
	end

	while not OpenListEmpty() do
		local lW, lWID = LowestNode()

		if not lW or not lWID then
			return nil, "Failed to find path"
		else
			Node[lW.x][lW.y].Closed = true
			Node[lW.x][lW.y].Open = false
			openlist[lWID] = nil
			curbase = lW
		end

		if curbase.x == tx and curbase.y == ty then
			return FixedPath()
		end

		local NearNodes = {}
		CheckNode(NearNodes,curbase.x,curbase.y+1)
		CheckNode(NearNodes,curbase.x+1,curbase.y)
		CheckNode(NearNodes,curbase.x,curbase.y-1)
		CheckNode(NearNodes,curbase.x-1,curbase.y)
		if Map(curbase.x+1,curbase.y) == 0 and Map(curbase.x,curbase.y+1) == 0 then CheckNode(NearNodes,curbase.x+1,curbase.y+1) end
		if Map(curbase.x+1,curbase.y) == 0 and Map(curbase.x,curbase.y-1)== 0 then CheckNode(NearNodes,curbase.x+1,curbase.y-1) end
		if Map(curbase.x-1,curbase.y) == 0 and Map(curbase.x,curbase.y+1) == 0 then CheckNode(NearNodes,curbase.x-1,curbase.y+1) end
		if Map(curbase.x-1,curbase.y) == 0 and Map(curbase.x,curbase.y-1) == 0 then CheckNode(NearNodes,curbase.x-1,curbase.y-1) end
		for i = 1, #NearNodes do
			AddNode(NearNodes[i], NearNodes[i].parent or curbase)
		end
	end
	return nil, "Couldn't find the path"
end

function PathWalkable(path)
	for k, v in pairs(path) do
		if not tile(v.x,v.y,"walkable") then
			return false
		end
	end
	return true
end

function AngleBetween(...)
	if #arg < 4 then return nil end
	local Angle = math.atan2(arg[2] - arg[4],arg[1] - arg[3]) - math.pi/2
	if Angle < -math.pi then
		Angle = Angle + (math.pi*2)
	end
	return Angle
end

function DistBetween(a, b, x, y)
	return math.sqrt((a - x)^2 + (b - y)^2)
end

function FixRot(angle)
	while angle < -180 do angle = angle + 360 end
	while angle > 180 do angle = angle - 360 end
	return angle
end

addhook("use","npc_onUse")
function npc_onUse(id)
	for k, npc in pairs(NPC_Tab) do
		npc:onUseEvent(id, v:dist(player(id,"x"), player(id,"y")))
	end
end

addhook("hitzone","npc_hit")
function npc_hit(id,p,o,w,x,y)
	local npc = NPC_Tab[id]
	if npc then
		local dmg = itemtype(w, "dmg")
		if dmg then
			npc:onHit(p, w, dmg, false)
		end
	end
end

addhook("always","npc_Always")
function npc_Always()
	for k, npc in pairs(NPC_Tab) do
		if object(k, "exists") then
			for timer_id = 1, #npc.timer, 1 do
				if Millisecs() - npc.timer[i][1] >= 0 then
					npc.timer[i][2](unpack(npc.timer[i][3]))
					npc.timer[i] = nil
				end
			end

			npc:Always()

			if npc:moveAvail() then
				if npc:onMoveEvent() then
					npc.last_move = Millisecs()
				end
			end

			local id, isNPC = npc:find_target()
			if id then
				if npc:checkVisual(object_x(id, isNPC), object_y(id, isNPC)) then
					npc:onSeeEnemy(id, isNPC)
					npc.lastTarget = id
					npc.lastVisual = true
					npc.targetNPC = isNPC
				end
			end

			if npc.lastTarget > 0 then
				local targetID = npc.lastTarget
				local targetNPC = npc.targetNPC
				local lastVisual = npc.lastVisual

				local target_x = object_x(targetID, targetNPC)
				local target_y = object_y(targetID, targetNPC)
				local target_health = object_health(targetID, targetNPC)
				local target_exists = target_x and target_y and target_health

				npc.targetx = target_x
				npc.targety = target_y
				npc.targetAttackable = npc:attackable(npc.targetx, npc.targety)
				npc.targetLine = npc:freeline(npc.targetx, npc.targety)

				if target_exists and target_health > 0 and npc:checkVisual(target_x, target_y) then
					local dist = npc:dist(target_x, target_y)
					if dist <= npc.attackdist and npc.targetAttackable then
						if npc.attackmindist and dist > npc.attackmindist then
							npc:findTargetPath(targetID, targetNPC)
						end

						if Millisecs() - npc.last_attack >= npc.attackdelay then
							npc.last_attack = Millisecs()
							npc:onAttack(targetID, targetNPC)
						end
					else
						npc:findTargetPath(targetID, targetNPC)
					end
					npc:aim(target_x, target_y)
				else
					npc:lostVisual(targetID, targetNPC)
					if target_exists and target_health > 0 then
						if npc:checkVisual(target_x, target_y) then
							npc:findTargetPath(targetID, targetNPC)
						end
					end
				end
			end

			if npc.health <= 0 then
				-- Anti death bug
				npc:onDie()
			end
		end
	end
end

addhook("parse","npc_onparse")
function npc_onparse(cmd)
	local s = {}
	for word in cmd:gmatch("[^%s]+") do table.insert(s, word) end
	if s[1] == "spawnlnpc" then
		local name,x,y,rot = s[2],tonumber(s[3]),tonumber(s[4]),tonumber(s[5])
		if name and x and y and rot then
			local b, e = SpawnNPC(name, x*32+16, y*32+16,rot)
			if not b then
				print("NPC Error: "..e)
			end
		elseif not name then
			print("Missing NPC name")
		elseif not x then
			print("Missing X coordinate")
		elseif not y then
			print("Missing Y coordinate")
		elseif not rot then
			print("Missing rotation")
		end
		return 1
	end
end

addhook("startround","onStart")
function onStart()
	for k, v in pairs(NPC_Tab) do
		NPC_Tab[k] = nil
	end
end

function TileDirt(x,y)
	return tile(x,y,"property") == 10
end

function TileSnow(x,y)
	return tile(x,y,"property") == 11
end

function TileStep(x,y)
	return tile(x,y,"property") == 12
end

function TileTile(x,y)
	return tile(x,y,"property") == 13
end

function TileWater(x,y)
	return tile(x,y,"property") == 14
end

function TileMetal(x,y)
	return tile(x,y,"property") == 15
end

function TileWood(x,y)
	return tile(x,y,"property") == 16
end

function object_x(id,isNPC)
	if isNPC and NPC_Tab[id] then
		return NPC_Tab[id]:x()
	elseif player(id,"exists") then
		return player(id,"x")
	end
end

function object_y(id,isNPC)
	if isNPC and NPC_Tab[id] then
		return NPC_Tab[id]:y()
	elseif player(id,"exists") then
		return player(id,"y")
	end
end

function object_health(id,isNPC)
	if isNPC and NPC_Tab[id] then
		return NPC_Tab[id].health
	elseif player(id,"exists") then
		return player(id,"health")
	end
end

dofile("sys/lua/NPC_Mod/npcscripts/zombie.lua")
dofile("sys/lua/NPC_Mod/npcscripts/hl2_strider.lua")
dofile("sys/lua/NPC_Mod/npcscripts/hl_headcrab.lua")
dofile("sys/lua/NPC_Mod/npcscripts/hl_houndeye.lua")
dofile("sys/lua/NPC_Mod/npcscripts/hl_agrunt.lua")
dofile("sys/lua/NPC_Mod/npcscripts/hl_bullsquid.lua")
